pub trait Component {
    type ParentMsg;
    type Msg;

    fn process(&mut self, msg: Self::Msg) -> Vec<Self::ParentMsg>;

    fn process_all(&mut self, msgs: impl Iterator<Item = Self::Msg>) -> Vec<Self::ParentMsg> {
        msgs.map(|msg| self.process(msg)).flatten().collect()
    }
}
